{ this was based on the blowit pascal source file from the blowit.pdf file,
  only problem(s) was(were) it used a unit called VTD that was not included
  and was impossible to find ANYWHERE! unfortunately it was quite important
  as it did the delays - so I've rewritten parts of it so that it should
  work ok on any computer BUT ONLY IN REAL DOS MODE. it will NOT work under
  windows, use py2051 if you need that. It has been written so it should work
  on any speed pc, I've tried it on a PIII 850, and on a 16MHZ 286 and it
  worked on both. I've also added support for Intel hex files and made it
  able to program the AT89C1051, 2051 and 4051. Good luck...}

Program BlowIt2051;
{Uses VTD;}
uses crt;
var
   base: Word;
   i, j, k, l: Integer;
   mem: Array[0..4095] of byte;
   f: file;
   del : integer;
   c,inki : char;
   chip : string[9];
   count : word;

Const
     inc_bit = $01;
     vpp_bit = $02;
     prog_bit = $04; { not inverse! }
     erase_bit = $08;
     prog_mode = $0F;
     erase_mode = $07;
     idle = $09; { Idle, RST = 0 }

label
     err_exit;

function deci(hh : string) : byte;
var oo,pp : byte;     {function that returns the byte value of a hex string}
begin
     pp := 0;
     oo := ord(upcase(hh[1]))-48;
     if oo > 10 then oo := oo - 7;
     pp := oo * 16;
     oo := ord(upcase(hh[2]))-48;
     if oo > 10 then oo := oo - 7;
     pp := pp + oo;
     deci := pp;
end;

procedure readfile;  {procedure to read hex file, then convert it to binary}
var                  {then load it into the mem array to be sent to the chip}
   f1 : text;        {Yes, I am well aware that it is VERY badly written and}
   s,data : string;  {when I look back at it in a years time I'm going to be}
   addr : string[4]; {embarrassed to see it, but it works and only took 10 }
   len,typ,temp : string[2];  {mins to write, so tough...}
   x : integer;
   waddr : integer;
begin
     writeln;
     assign(f1,paramstr(1));
     {$I-}
          reset(f1);
          x:=ioresult;
     {$I+}
     If x <> 0 then
     begin
          Writeln('File not found!');
          halt(2); { File error }
     end;
     waddr:=0;
     write('Reading file: ',paramstr(1),'...  ');
     for x := 0 to 4095 do mem[x]:=255;  {make whole array = $FF}
     while not eof(f1) do
     begin
          readln(f1,s);        {reads a line from the hex file}
          if s[1] <> ':' then  {checks if it starts with a : to show its a}
          begin                {valid intel hex file}
               writeln('Error, Invalid hex file!');
               halt(1);
          end;
          delete(s,1,1);
          len:=s; delete(s,1,2); {length of data}
          addr:=s; delete(s,1,4); {Start address of data}
          typ:=s; delete(s,1,2);  {type of data}
          data:=s; delete(data,(deci(len)*2)+1,2); {gets data}
          if typ='00' then         {if type is data then:}
          begin
               waddr:=(deci(addr[1]+addr[2])*256)+deci(addr[3]+addr[4]); {work out the start address of the data}
               for x := 1 to deci(len) do {loop "length of data" times}
               begin
                    temp:=data;  {put the first byte of data into temp}
                    delete(data,1,2); {delete first byte from data string}
                    mem[waddr]:=deci(temp); {convert hex to byte and put it into correct place in mem array}
                    inc(waddr); {increment address counter}
               end;
          end;
     end;
     writeln('Read ',waddr,' bytes.');
     writeln;
     if waddr<1 then
     begin
          writeln('So there isn''t really much point programming it is there?!');
          halt(1);
     end;
     if waddr>(count+1) then   {check if end address is less than max for selected device}
     begin
          writeln('Error, File too big for target device!');
          halt(0);
     end;
     close(f1);
end;

procedure nms(i : integer);
var m,x : longint;
    t : longint absolute $40:$6C;
begin           {procedure that takes approx 1 (ish!) mS}
     x:=0;
     m := t + i;
     repeat x:=x+1 until t >= m;
end;

procedure startdel;
var m,x : longint;
    t : longint absolute $40:$6C;
begin
     x:=0;          {procedure to work out how many instructions it takes to}
     m := t + 1;    {a 10ms delay}
     repeat x:=x+1 until t >= m;
     del:=x div 2200;
end;

procedure delay_mks(iii : integer);
var x,y,d : integer;
begin
     y:=iii*del;  {basically does a loop for iii * the worked out delay to give}
     for x := 1 to y do  {an approximate iii uS delay }
     begin
          d:=x+iii+y;  {just takes up a bit of time}
     end;
end;

Procedure Chk;   {wait for key to be pressed}
Begin
      Inki  := ReadKey;
End;

begin
     clrscr;
     del:=0;
     startdel;{this works out how many instructions it takes to do a timed}
     startdel;{function that is based on the real time clock, not the }
     startdel;{processor speed so the delays will be the same on any speed pc}
     Writeln;
     Writeln('----- BlowIT (tm) x051 ver 1.0 beta -----');
     Writeln('           Modified by DM 2003');
     Writeln;
     if ParamCount<1 then
     begin
          Writeln('usage: Blowit filename.hex [n]');
          Writeln('usage: n=1,2,3 LPT number to use');
          Writeln;
          halt(1);
     end;
     c:='1';                          {w}
     base := memw[$40:8];             {o}
     if ParamStr(2) = '2' then        {r}
     begin                            {k}
          base := memw[$40:10];       { }
          c:='2';                     {o}
     end;                             {u}
     if ParamStr(2) = '3' then        {t}
     begin                            { }
          base := memw[$40:12];       {p}
          c:='3';                     {o}
     end;                             {r}
     If base = 0 then                 {t}
     begin
          Writeln('Parallel port does not exist!');
          Halt(2);
     end;
     write('Select Target Device: ');
     writeln('(1) - AT89C1051  (2) - AT89C2051  (3) - AT89C4051');
     repeat
           chk;       {wait for key to be pressed, then make sure its a recognised one}
     until (inki='1')or(inki='2')or(inki='3')or(inki=#27);
     if inki=#27 then halt(1); {if escape pressed, terminate}
     if inki='1' then begin chip:='AT89C1051'; count:=1023; end; {set up type of chip}
     if inki='2' then begin chip:='AT89C2051'; count:=2047; end; {and the max mem}
     if inki='3' then begin chip:='AT89C4051'; count:=4095; end; {address}
     readfile;      {read and concert the file}
     writeln('Programming '+chip+' on Port: ',c);
     write('Erasing');
     port[base] := $FF;

     { Erase }
     port[base+2] := $01;
     nms(2{10});
     port[base+2] := $03; { RST = 12 }
     nms(1);
     port[base+2] := erase_mode; { RST = 12, PROG = H }
     nms(1);
     write('.');
     port[base+2] := erase_mode xor prog_bit; { P3.2 = 0 }
     nms(3{12}); { This is ERASE PULSE!}
     write('.');
     port[base+2] := erase_mode; { P3.2 = 1 }
     nms(3{12});
     write('.');
     port[base+2] := erase_mode xor vpp_bit; { RST = 0 }
     nms(5{20});
     write('.');
     { Program ROM }
     port[base+2] := idle;
     nms(2{10});
     port[base+2] := idle or vpp_bit;
     nms(2{10});
     writeln('.');
     port[base+2] := prog_mode; { RST = 12, PROG = H }
     nms(1);
     Write('Programming  ');
     k := 0; l := 0;
     for j := 0 to count do {so do count number of loops, depending}
     begin                  {on type of selected target processor}
          port[base] := mem[j];
          if mem[j] <> $FF then
          begin
               delay_mks(2);

               { PROG Pulse}
               port[base+2] := prog_mode xor prog_bit; { P3.2 = 0 }
               delay_mks(5);
               port[base+2] := prog_mode; { P3.2 = 1 }
               delay_mks(2);
               i := 0;
               while (port[base+1] and 64) = 0 do
               begin
                    delay_mks(10);
                    if i>200 then
                    begin
                         Writeln;
                         Writeln('Error, device timeout!');
                         goto err_exit;
                    end;
                    if i > k then k := i;
                    inc(i);
               end;
               if l > 30 then
               begin
                    Writeln;
                    Writeln('Error, device not detected!');
                    goto err_exit;
               end;
               if i = 0 then inc(l);
               delay_mks(2);
          end;
          port[base+2] := prog_mode xor inc_bit; { XT1 = 1 }
          delay_mks(5);
          port[base+2] := prog_mode; { XT1 = 1 }
          delay_mks(2);
          if (j mod 64) = 0 then Write('.');
     end;
     port[base] := $FF; nms(1);
     port[base+2] := prog_mode xor vpp_bit; { P3.2 = 0!! }
     nms(1);
     port[base+2] := idle;
     port[base] := $00;
     Writeln;
     Writeln('Programming Complete.');
     Halt(0);

     err_exit:
     Halt(1);
end.
